import { system, world } from "@minecraft/server";


const recipes = [
    {
        output: "beef_jerky",
        ingredients: [
            { item: "minecraft:rotten_flesh", count: 1 },
            
        ],
    },
    {
        output: "green_raisins",
        ingredients: [
            { item: "ww_dx:green_grapes", count: 1 },
        ],
    },
    {
        output: "purple_raisins",
        ingredients: [
            { item: "ww_dx:purple_grapes", count: 1 },
        ],
    },
    {
        output: "red_raisins",
        ingredients: [
            { item: "ww_dx:red_grapes", count: 1 },
        ],
    },
];




const dehydrator = new Map(); 


function processDehydratorInventory(entity) {
    const id = entity.id;

    if (dehydrator.get(id)?.isProcessing) {
        return;
    }

    const inventoryComponent = entity.getComponent("minecraft:inventory");

    if (!inventoryComponent || !inventoryComponent.container) {

        return;
    }

    const inventory = inventoryComponent.container;

    for (const recipe of recipes) {
      
        let matches = true;

        const ingredientsMap = new Map(
            recipe.ingredients.map((ingredient) => [ingredient.item, ingredient.count])
        );

        for (let i = 0; i < inventory.size; i++) {
            const item = inventory.getItem(i);
            if (item) {
                if (ingredientsMap.has(item.typeId)) {
                    const remainingCount = ingredientsMap.get(item.typeId) - item.amount;
                    if (remainingCount <= 0) {
                        ingredientsMap.delete(item.typeId);
                    } else {
                        ingredientsMap.set(item.typeId, remainingCount);
                    }
                } else {
                    
                    matches = false;
                    break;
                }
            }
        }

        if (matches && ingredientsMap.size === 0) {
            entity.runCommandAsync("summon ww_dx:processing_particle ~ ~1 ~")

          
            for (const ingredient of recipe.ingredients) {
                let remainingToRemove = ingredient.count;

                for (let i = 0; i < inventory.size; i++) {
                    const item = inventory.getItem(i);
                    if (item && item.typeId === ingredient.item) {
                        if (item.amount > remainingToRemove) {
                            item.amount -= remainingToRemove;
                            inventory.setItem(i, item);
                            break;
                        } else {
                            remainingToRemove -= item.amount;
                            inventory.setItem(i, undefined);
                        }
                    }
                }
            }


            dehydrator.set(id, { isProcessing: true });
            system.runTimeout(() => {
                if (!entity.isValid()) return;
                const { x, y, z } = entity.location;
                entity.runCommandAsync(`loot spawn ${x} ${y + 1} ${z} loot ${recipe.output}`);
                entity.runCommandAsync("event entity @e[type=ww_dx:processing_particle,r=1] ww_dx:despawn")
                entity.runCommandAsync("playsound ww_dx:finish_cooking @a[r=5]")
  
                dehydrator.set(id, { isProcessing: false });
            }, 200);

            return; 
        } else {
         
        }
    }


}
let worldInitialize = false;
world.afterEvents.playerSpawn.subscribe((event) => {
    worldInitialize = true;

})
function checkDehydrator() {
    if(!worldInitialize)return;
    const currentDimension = world.getDimension(world.getPlayers()[0].dimension.id);

    for (const entity of currentDimension.getEntities()) {
        if (entity.typeId === "ww_dx:dehydrator") {
            if (!dehydrator.has(entity.id)) {
                dehydrator.set(entity.id, { isProcessing: false });

            }

            processDehydratorInventory(entity);
        }
    }
}


system.runInterval(() => {
    checkDehydrator();
}, 20);
